> ## Documentation Index
> Fetch the complete documentation index at: https://ubicloud.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List all VMs



## OpenAPI

````yaml /api-reference/openapi.yml get /project/{project_id}/vm
openapi: 3.0.3
info:
  description: API for managing resources on Ubicloud
  title: Clover API
  version: 0.1.0
  contact:
    url: https://www.ubicloud.com/
    email: support@ubicloud.com
  license:
    name: GNU Affero General Public License v3.0 (AGPL-3.0)
    url: https://www.gnu.org/licenses/agpl-3.0.en.html
servers:
  - url: https://api.ubicloud.com
security:
  - BearerAuth: []
tags:
  - description: Firewall Operations
    name: Firewall
  - description: Firewall Rule Operations
    name: Firewall Rule
  - description: Inference API Key Operations
    name: Inference Api Key
  - description: Inference Endpoint Operations
    name: Inference Endpoint
  - description: Load Balancer Operations
    name: Load Balancer
  - description: Login Operations
    name: Login
  - description: Machine Image Operations
    name: Machine Image
  - description: Postgres Database Operations
    name: Postgres Database
  - description: Postgres Firewall Rule Operations
    name: Postgres Firewall Rule
  - description: Postgres Metric Destination
    name: Postgres Metric Destination
  - description: Postgres Log Destination
    name: Postgres Log Destination
  - description: Private Subnet Operations
    name: Private Subnet
  - description: Project Operations
    name: Project
  - description: Virtual Machine Operations
    name: Virtual Machine
  - description: Private Location Operations
    name: Private Location
  - description: Kubernetes Cluster Operations
    name: Kubernetes Cluster
  - description: SSH Public Key Operations
    name: SSH Public Key
  - description: GitHub Operations
    name: GitHub
  - description: Audit Log Operations
    name: Audit Log
paths:
  /project/{project_id}/vm:
    get:
      tags:
        - Virtual Machine
      summary: List all VMs
      operationId: listProjectVMs
      parameters:
        - $ref: '#/components/parameters/project_id'
        - $ref: '#/components/parameters/start_after'
        - $ref: '#/components/parameters/page_size'
        - $ref: '#/components/parameters/order_column'
      responses:
        '200':
          $ref: '#/components/responses/Vms'
        default:
          $ref: '#/components/responses/Error'
components:
  parameters:
    project_id:
      description: ID of the project
      in: path
      name: project_id
      required: true
      schema:
        type: string
        example: pjkkmx0f2vke4h36nk9cm8v8q0
        pattern: ^pj[0-9a-hj-km-np-tv-z]{24}$
    start_after:
      description: Pagination - Start after
      in: query
      name: start_after
      required: false
      schema:
        type: string
    page_size:
      description: Pagination - Page size
      in: query
      name: page_size
      required: false
      schema:
        type: integer
        default: 10
    order_column:
      description: Pagination - Order column
      in: query
      name: order_column
      required: false
      schema:
        type: string
        default: id
  responses:
    Vms:
      description: A list of VMs
      content:
        application/json:
          schema:
            type: object
            properties:
              count:
                type: integer
              items:
                type: array
                items:
                  $ref: '#/components/schemas/Vm'
            additionalProperties: false
            required:
              - count
              - items
    Error:
      description: An error response
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
  schemas:
    Vm:
      type: object
      properties:
        boot_image:
          description: Boot image of the VM
          type: string
        id:
          description: ID of the VM
          type: string
          example: vmhfy8gff8c67hasb0eez2k1pd
          pattern: ^vm[0-9a-hj-km-np-tv-z]{24}$
        ip4:
          description: IPv4 address
          type: string
          format: ipv4
          nullable: true
        ip4_enabled:
          description: Whether IPv4 is enabled
          type: boolean
        ip6:
          description: IPv6 address
          type: string
          format: ipv6
          nullable: true
        location:
          description: Location of the VM
          type: string
          example: eu-central-h1
        name:
          description: Name of the VM
          type: string
          example: my-vm-name
        size:
          description: Size of the underlying VM
          type: string
        state:
          description: State of the VM
          type: string
        storage_size_gib:
          description: Storage size in GiB
          type: integer
        unix_user:
          description: Unix user of the VM
          type: string
      additionalProperties: false
      required:
        - boot_image
        - id
        - ip4
        - ip4_enabled
        - ip6
        - location
        - name
        - size
        - state
        - storage_size_gib
        - unix_user
    Error:
      type: object
      properties:
        error:
          type: object
          additionalProperties: false
          properties:
            code:
              type: integer
              example: 401
            message:
              type: string
              example: There was an error logging in
            type:
              type: string
              example: InvalidCredentials
            details:
              type: object
              nullable: true
          required:
            - code
            - message
            - type
      additionalProperties: false
      required:
        - error
  securitySchemes:
    BearerAuth:
      bearerFormat: JWT
      scheme: bearer
      type: http

````